package mccity.heroes.skills.turret;

import com.herocraftonline.heroes.characters.Hero;
import com.herocraftonline.heroes.characters.skill.SkillConfigManager;
import com.herocraftonline.heroes.util.Setting;
import org.bukkit.block.Block;

public class TurretBuilder {

    private final SkillTurret skill;

    private final float yOffsetOverBaseBlock = 1.6f;
    private final float scanRadius = 25;
    private final int switchTargetPeriodTicks = 80;

    public TurretBuilder(SkillTurret skill) {
        this.skill = skill;
    }

    public Turret build(Hero hero, Block base) {
        int attackPeriodTicks = SkillConfigManager.getUseSetting(hero, skill, "attack-period-ticks", 20, true);
        float damage = SkillConfigManager.getUseSetting(hero, skill, Setting.DAMAGE, 3, true);
        int knockback = SkillConfigManager.getUseSetting(hero, skill, "knockback", 0, false);
        boolean fireArrow = SkillConfigManager.getUseSetting(hero, skill, "fire-arrow", false);
        int initialAmmo = skill.getInitialAmmoFor(hero);
        int ammoPerArrow = skill.getAmmoPerArrowFor(hero);

        return new Turret(hero, base, attackPeriodTicks, damage, knockback, fireArrow, yOffsetOverBaseBlock, scanRadius, switchTargetPeriodTicks, initialAmmo, ammoPerArrow);
    }
}
